<?php
/*
Plugin Name: Entreprenörswidget Klient
Plugin URI: http://disruptive.nu
Description: A widget to display rss feeds from other blogs to  your own blog.
Version: 1.0
Author: Disruptive.nu
Author URI: http://disruptive.nu
License: GPL2
*/

define('ENTREPRENEUR_FEED_SERVER_URL', 'http://disruptive.nu/wp-content/plugins/entrepreneur-feeds-widget/entrepeneurefeedswidget.php?feeds=true&plugin=EntrepeneureFeeds&type=json');

class DisruptiveRssWidget extends WP_Widget
{
	var $data;
	private static $PLUGIN_OPTION_UPDATED = "DISRUPTIVE_UPDATED_CLIENT";
	private static $PLUGIN_OPTION_CONTENT = "DISRUPTIVE_CONTENT_CLIENT";
	
    function DisruptiveRssWidget(){
		global $is_IE;		
		
		if(get_option(self::$PLUGIN_OPTION_UPDATED) != false && get_option(self::$PLUGIN_OPTION_UPDATED) == date('Y-m-d'))
			$response = unserialize(get_option(self::$PLUGIN_OPTION_CONTENT));					
		else		
			$response = wp_remote_get(ENTREPRENEUR_FEED_SERVER_URL, array('timeout' => 60));
				
		
		/*
		if (file_get_contents(__DIR__ . '/feed_updated.txt')  == date('Y-m-d')  )
		{
			$response = unserialize(file_get_contents(__DIR__ . '/feed_content.txt'));
		}
		else
		{		
			$response = wp_remote_get(ENTREPRENEUR_FEED_SERVER_URL, array('timeout' => 60));
		}
		*/


		$this->data = (object) array(
			'options' => (object) array(
				'api_url' => ENTREPRENEUR_FEED_SERVER_URL
			),
			'error' => (object) array(
				'code' => '',
				'message' => ''
			)
		);
                
		if (is_wp_error($response)) {
			$this->data->error->code = 1;
			$this->data->error->message = $response->get_error_message();
		} else {
			$this->data->error->code = $response['response']['code'];
			$this->data->error->message = $response['response']['message'];
		}
		if ($this->data->error->code == '200') {
			//file_put_contents(__DIR__ . '/feed_content.txt', serialize($response));
			//file_put_contents(__DIR__ . '/feed_updated.txt', date('Y-m-d'));
			
			//update the options to have latest values
			update_option(self::$PLUGIN_OPTION_CONTENT, serialize($response));
			update_option(self::$PLUGIN_OPTION_UPDATED, date('Y-m-d'));						
			
			$body = json_decode($response['body']);
			$this->data->options->date_format = $body->options->date_format;
			$this->data->options->css_url = $body->options->css_url;
			//$this->data->options->ie_css_url = $body->options->ie_css_url;
			$this->data->items = $body->items;
                        
			wp_enqueue_style('entrepreneur_feeds', $this->data->options->css_url);
			if ($is_IE) {
				//wp_enqueue_style('rss_feeds_ie', $this->data->options->ie_css_url);
			}
		}
	
		$widget_ops = array( 'description' => 'A widget to display rss feeds from other blogs to  your on blog.' );
		parent::WP_Widget( false, $name='Entreprenörswidget', $widget_ops, null );
    }

	/* Displays the Widget in the front-end */
    function widget( $args, $instance ){
		global $post;
		
		extract($args);	
		$title = apply_filters( 'widget_title', empty( $instance['title'] ) ? 'Entrepren&ouml;rswidget' : esc_html( $instance['title'] ) );
		
		echo $before_widget;		
		if ( $title ) 
			echo $before_title . $title . $after_title;
			
		$height = apply_filters( 'widget_height', empty( $instance['height'] ) ? '160px' : esc_html( $instance['height'] ) );
		$error = $this->data->error;

		if ($error->code != '200') {
			echo 'ERROR: '.$error->message;
		} else {
			$options = $this->data->options;
			$items = $this->data->items;
			$output .= '<div class="entrepeneurefeedxyzaq124" style="height:auto;">';
			$output .= '<div id="entrepeneure-rss-feed-widget" style="height:'.$height.';">';
			$output .= '<div class="Ewizheaderback"></div>';
			$output .= '<ul ><span style=" display: block;font-weight: 700;font-size:.86em; margin-bottom: 5px; text-align: center;"> Nya l&auml;nkar fr&aring;n bloggar </span>';
			foreach ($items as $item) {
				$output .= '<li class="single-feed '.$item->class.'"><span class="arrow"></span><a target="_NEW" title="'.date_i18n( $options->date_format, $item->date ).'" href="'.$item->permalink.'">'.$item->title.'</a>' ;
				$output .= '<br/> <small><site>'.$item->name.'</site></small>' ;
				$output .= '</li>';
				$output .= '<span class="esingle-feed-seperator"></span>';
			}
			$output .= '</ul>';
			$output .= '</div>';
			$output .= '<div class="mulrssfeedxyzp" style="margin:0px;width:156px;text-algin:center;height:65px">';
			$output .= '<span style="display: block;text-align: center;"><span style="font-weight:bold;color:#06c;text-decoration: underline"><a href="http://disruptive.nu/" target="_blank">disruptive.nu</a></span></span>';
			$output .= '<span style=" display:block;text-align: center;"><a href="http://disruptive.nu/bloggwidget/" target="_blank">L&#196;GG TILL DENNA TILL DIN BLOGG</a></span>';
			$output .= '</div>';
			$output .= '</div>';

			$output = apply_filters('entrepreneur_feeds_html', $output);
			echo $output;
		}

		echo $after_widget;
	}

	/*Saves the settings. */
    function update( $new_instance, $old_instance ){
		$instance = $old_instance;
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['height'] = strip_tags( $new_instance['height'] );
		
		return $instance;
	}

	/*Creates the form for the widget in the back-end. */
    function form( $instance ){
		//Defaults
		$instance = wp_parse_args( (array) $instance, array( 
			'title' => 'Entrepreneur Feed Widget',
			'height' => 'auto'
		) );

		$title = esc_attr( $instance['title'] );
		$height = esc_attr( $instance['height'] );
		# Title
		echo '<p><label for="' . $this->get_field_id('title') . '">' . 'Title:' . '</label><input class="widefat" id="' . $this->get_field_id('title') . '" name="' . $this->get_field_name('title') . '" type="text" value="' . $title . '" /></p>';
		echo '<p><label for="' . $this->get_field_id('height') . '">' . 'Height:' . '</label><input class="widefat" id="' . $this->get_field_id('height') . '" name="' . $this->get_field_name('height') . '" type="text" value="' . $height . '" /></p>';
	}

}// end

function DisruptiveRssWidgetInit() {
	if ( ! isset($_GET['feeds']) || ! isset($_GET['type']) || ! isset($_GET['plugin'])) {
		register_widget('DisruptiveRssWidget');
	}
}

add_action('widgets_init', 'DisruptiveRssWidgetInit');
